<?php

function bcash_config() {
	$configarray = array(
     "FriendlyName" => array("Type" => "System", "Value"=>"B!Cash com retorno automático"),
     "conta" => array("FriendlyName" => "Conta", "Type" => "text", "Size" => "40", "Description" => "Email de sua conta no B!Cash.", ),
	 "token" => array("FriendlyName" => "Chave de acesso", "Type" => "text", "Size" => "40", "Description" => "Você pode encontrar em: Ferramentas > Códigos Integração, no painel do B!Cash.", ),
	 "taxa" => array("FriendlyName" => "Taxa %", "Type" => "text", "Size" => "6", "Value" => "2.89", "Description" => "Taxa em porcentagem. Ex: use 4.5 para 4,5%. <a href='https://www.bcash.com.br/tarifas-bcash.html'>Taxas do B!Cash</a>.", ),
	 "adicional" => array("FriendlyName" => "Taxa auxiliar", "Type" => "text", "Size" => "6", "Value" => "0.00", "Description" => "Valor adicional. Ex: 0.50 (50 centavos).", ),
	 "isencao" => array("FriendlyName" => "Isenção", "Type" => "text", "Size" => "6", "Value" => "100.00", "Description" => "Isentar clientes das taxas a partir do valor informado. Ex: 100.00 (R$ 100). (em branco para desativar)", ),
	 "target" => array("FriendlyName" => "Target", "Type" => "dropdown", "Options" => "_blank,_self", "Description" => "Target do formulário. _blank - nova janela, _self - padrão", ),
	 "botao" => array("FriendlyName" => "Imagem", "Type" => "text", "Size" => "40", "Value" => "https://bcash.com.br/webroot/img/bt_comprar.gif", "Description" => "Imagem do botão na fatura. (em branco para desativar).", ),
	 "title" => array("FriendlyName" => "Texto da imagem", "Type" => "text", "Size" => "40", "Value" => "Pagar com B!Cash", "Description" => "Title do botão.", ),
	 "status" => array("FriendlyName" => "Status da transação", "Type" => "text", "Size" => "40", "Value" => "%status%, em %data%, via %tipopagamento%, ID: %transid%", "Description" => "%status%, em %data%, via %tipopagamento%, ID: %transid% <img src='../images/help.gif' border='0' title='Aprovado, em 00/00/0000, via Boleto, ID: 123' />.", ),
     "obs" => array("FriendlyName" => "Observação", "Type" => "textarea", "Rows" => "5", "Description" => "Coloque aqui suas observações. (html permitido)", ),
     "redirecionar" => array("FriendlyName" => "Redirecionar", "Type" => "dropdown", "Options" => "Sim,Não", "Description" => "Redirecionar automaticamente para o pagamento.", ),
     "tempo" => array("FriendlyName" => "Tempo", "Type" => "text", "Size" => "6", "Value" => "10", "Description" => "Tempo para redirecionar na fatura (em segundos).", ),
    );
	return $configarray;	
}

function bcash_link($params) {

	# Variaveis da fatura
	$invoiceid = $params['invoiceid'];
	$description = $params["description"];
    $amount = $params['amount'];
    $currency = $params['currency'];

	# Variaveis do cliente
	$firstname = $params['clientdetails']['firstname'];
	$lastname = $params['clientdetails']['lastname'];
	$email = $params['clientdetails']['email'];
	$address1 = $params['clientdetails']['address1'];
	$address2 = $params['clientdetails']['address2'];
	$city = $params['clientdetails']['city'];
	$state = $params['clientdetails']['state'];
	$postcode = $params['clientdetails']['postcode'];
	$country = $params['clientdetails']['country'];
	$phone = $params['clientdetails']['phonenumber'];

	# Variaveis do sistema
	$companyname = $params['companyname'];
	$systemurl = $params['systemurl'];
	$currency = $params['currency'];
	$langpaynow = $params['langpaynow'];
	
	# Variaveis do modulo
	$moduloconta = $params['conta'];
	$modulotoken = $params['token'];
	$modulotaxa = $params['taxa'];
	$moduloadicional = $params['adicional'];
	$moduloisencao = $params['isencao'];
	$modulotarget = $params['target'];
	$modulobotao = $params['botao'];
	$modulotitle = $params['title'];
	$modulostatus = $params['status'];
	$moduloobs = $params['obs'];
	$moduloredirecionar = $params['redirecionar'];
	$modulotempo = $params['tempo'] * 1000;
	$url_aviso = $params['systemurl']."/modules/gateways/callback/bcash.php";
	$url_retorno = $params['systemurl']."/viewinvoice.php?id=".$invoiceid;

	
	if($moduloisencao != '') {
		if($moduloisencao <= $amount) {
			$taxa = 0;
		}
	}
	
	if($moduloisencao == '') {
		$taxa = ($modulotaxa * $amount) / 100 + $moduloadicional;
	}else 
	if($moduloisencao >= $amount) {
		$taxa = ($modulotaxa * $amount) / 100 + $moduloadicional;
	}
	
	
	if($moduloredirecionar == 'Sim') {
		$redirecionar = "<script>setTimeout('document.bcash.submit();',".$modulotempo.");</script>";
	}
	else {
		$redirecionar = "";
	}
	
	if($modulobotao == '') {
		$imagem = '<input type="submit" title="'.$modulotitle.'" alt="'.$modulotitle.'" value="'.$langpaynow.'">';
	}
	else {
		$imagem = '<input type="image" style="cursor:hand" title="'.$modulotitle.'" alt="'.$modulotitle.'" src="'.$modulobotao.'">';
	}

$estado = strtoupper($state);
	$acentos = array(
		'A' => array("Á", "À", "Â", "Ã", "Ä", "á", "à", "â", "ã", "ä", ),
		'E' => array("É", "È", "Ê", "Ë", "é", "è", "ê", "ë", ),
		'I' => array("Í", "Ì", "Î", "Ï", "í", "ì", "î", "ï", ),
		'O' => array("Ó", "Ò", "Ô", "Õ", "Ö", "ó", "ò", "ô", "õ", "ö", ),
		'U' => array("Ú", "Ù", "Û", "Ü", "ú", "ù", "û", "ü", ),
		'misc' => array(" ", ".", ",", ":", ";", "<", ">", "\\", "/",
		"\"", "'", "|", "?", "!", "@", "#", "$", "%", "&", "*", "(",
		")", "[", "]", "{", "}", "´", "`", "~", "^", "¨", "-", "_",
		"=", "+", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", ),
	);
	$estado = str_ireplace($acentos['A'], "A", $estado);
	$estado = str_ireplace($acentos['E'], "E", $estado);
	$estado = str_ireplace($acentos['I'], "I", $estado);
	$estado = str_ireplace($acentos['O'], "O", $estado);
	$estado = str_ireplace($acentos['U'], "U", $estado);
	$estado = str_ireplace($acentos['misc'], "", $estado);
	switch ($estado) {
		case "ACRE": $estado = "AC"; break;
		case "ALAGOAS": $estado = "AL"; break;
		case "AMAPA": $estado = "AP"; break;
		case "AMAZONAS": $estado = "AM"; break;
		case "BAHIA": $estado = "BA"; break;
		case "CEARA": $estado = "CE"; break;
		case "DISTRITOFEDERAL": $estado = "DF"; break;
		case "ESPIRITOSANTO": $estado = "ES"; break;
		case "GOIAS": $estado = "GO"; break;
		case "MARANHAO": $estado = "MA"; break;
		case "MATOGROSSO": $estado = "MT"; break;
		case "MATOGROSSODOSUL": $estado = "MS"; break;
		case "MINASGERAIS": $estado = "MG"; break;
		case "PARA": $estado = "PA"; break;
		case "PARAIBA": $estado = "PB"; break;
		case "PARANA": $estado = "PR"; break;
		case "PERNAMBUCO": $estado = "PE"; break;
		case "PIAUI": $estado = "PI"; break;
		case "RIODEJANEIRO": $estado = "RJ"; break;
		case "RIOGRANDEDONORTE": $estado = "RN"; break;
		case "RIOGRANDEDOSUL": $estado = "RS"; break;
		case "RONDONIA": $estado = "RO"; break;
		case "RORAIMA": $estado = "RR"; break;
		case "SANTACATARINA": $estado = "SC"; break;
		case "SAOPAULO": $estado = "SP"; break;
		case "SERGIPE": $estado = "SE"; break;
		case "TOCANTINS": $estado = "TO"; break;
	}
	
	$total = number_format($taxa + $amount, 2, '.', '');
	$code = '<br>
		Valor da fatura: <b>R$ '.$amount.'</b><br>
		Taxas de cobrança: <b>R$ '.number_format($taxa, 2, '.', '').'</b><br>
		Valor a pagar: <b>R$ '.number_format($total, 2, '.', '').'</b><br>
	<br>
	<form name="bcash" action="https://www.bcash.com.br/checkout/pay/" method="post" target="'.$modulotarget.'">
	<input name="email_loja" type="hidden" value="'.$moduloconta.'">
	<input name="produto_codigo_1" type="hidden" value="'.$invoiceid.'">
	<input name="produto_descricao_1" type="hidden" value="'.$description.'">
	<input name="produto_qtde_1" type="hidden" value="1">
	<input name="produto_valor_1" type="hidden" value="'.$total.'">
	<input name="produto_extra_1" type="hidden" value="">
	<input name="tipo_integracao" type="hidden" value="PAD">
	<input name="frete" type="hidden" value="">
	<input name="id_pedido" type="hidden" value="'.$invoiceid.'">
	<input name="email" type="hidden" value="'.$email.'">
	<input name="nome" type="hidden" value="'.$firstname.' '.$lastname.'">
	<input name="telefone" type="hidden" value="'.$phone.'">
	<input name="endereco" type="hidden" value="'.$address1.'">
	<input name="bairro" type="hidden" value="'.$address2.'">
	<input name="cidade" type="hidden" value="'.$city.'">
	<input name="estado" type="hidden" value="'.$estado.'">
	<input name="cep" type="hidden" value="'.$postcode.'">
	<input name="url_retorno" type="hidden" value="'.$url_retorno.'" >
	<input name="url_aviso" type="hidden" value="'.$url_aviso.'" >
	<input name="cliente_razao_social" type="hidden" value="'.$companyname.'">
	'.$imagem.'</form>
	<br><br>
	<div style="text-align:center;">'.$moduloobs.'</div>'.$redirecionar;
	return $code;
}

	$GATEWAYMODULE['bcashnotes'] = "
		<center><br>URL para retorno de dados: urldoseuwhmcs/modules/gateways/callback/bcash.php
		<br><br>
		<b>Criado por Victor Hugo Fernandes - <a href='mailto:vhmf171@gmail.com'>vhmf171@gmail.com</a></b>
		<br>
		<b>contato@htmlhost.com.br</b></center>";

?>